#define ADDON1
using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = UnityEngine.Object;
using System.Text.RegularExpressions;

namespace Cotyounoyume
{
    public class AddonManager1 : MonoBehaviour 
    {
		public Atom atom;
		public EBATCore core;
		private float lastTime;
		public WorldUIAddon1 worldUIAddon1;
#if(ADDON1)
		public AddonClothSimItem addonClothSim;			
#endif			

		public bool wrapChangeOnGlobal = true;		
		public bool holdNGWordsOnGlobal = true;
		public bool holdClothSimOnGlobal = true;
		public bool holdSkinWrapOnGlobal = true;
		public bool wrapAlterToSimOnGlobal = true;
		
		public AddonManager1(EBATCore core){
			atom = core.atom;
			this.core = core;
			
			StartConstructor();
		}

		public void StartConstructor(){
#if(ADDON1)
			addonClothSim         = new AddonClothSimItem(core);			
#endif			
		}
		
		public void DoWorldUIAddon1Function(string func){
#if(ADDON1)
			if(func == "Construct"){
				worldUIAddon1 = new WorldUIAddon1(core.worldUi);
			}else if(func == "RemoveMenuBodyAddon"){
				worldUIAddon1.RemoveMenuBodyAddon();
			}else if(func == "MakeMenuBodyAddon"){
				worldUIAddon1.MakeMenuBodyAddon();				
			}else if(func == "ExpandAddon1All"){
				worldUIAddon1.OnExpandAddon1ValueOnly();		
			}else if(func == "CollapseAddon1All"){
				worldUIAddon1.OnCollapseAddon1ValueOnly();		
			}else if(func == "LabelSwitch"){
				worldUIAddon1.LabelSwitch();		
			}else if(func == "OnUndressAndRemoveClick"){
				worldUIAddon1.OnUndressAndRemoveClick();		
			}else if(func == "OnUndressClick"){
				worldUIAddon1.OnUndressClick();		
			}else if(func == "OnUndressForceClick"){
				worldUIAddon1.OnUndressForceClick();		
			}else if(func == "OnReverseClick"){
				worldUIAddon1.OnReverseClick();		
			}else if(func == "OnUndressAndReverseClick"){
				worldUIAddon1.OnUndressAndReverseClick();		
			}else if(func == "OnUndressRevStrongClick"){
				worldUIAddon1.OnUndressRevStrongClick();		
			}else if(func == "OnAltSkinWrapClick"){
				worldUIAddon1.OnAltSkinWrapClick();		
			}else if(func == "OnUndressStopClick"){
				worldUIAddon1.OnUndressStopClick();		
			}else if(func == "OnUndressRecoverClick"){
				worldUIAddon1.OnUndressRecoverClick();		
			}else if(func == "OnExposeBreastsClick"){
				worldUIAddon1.OnExposeBreastsClick();		
			}else if(func == "OnExposeBreastsStrongClick"){
				worldUIAddon1.OnExposeBreastsStrongClick();		
			}else if(func == "OnPullUpSkirtClick"){
				worldUIAddon1.OnPullUpSkirtClick();		
			}else if(func == "OnRemoveGameObjectsClick"){
				worldUIAddon1.OnRemoveGameObjectsClick();		
			}else if(func == "OnUndressRemoveClick"){
				worldUIAddon1.OnUndressRemoveClick();		
			}else if(func == "OnUndressOpt1Click"){
				worldUIAddon1.OnUndressOpt1Click();		
			}else if(func == "OnUndressOpt2Click"){
				worldUIAddon1.OnUndressOpt2Click();		
			}else if(func == "OnUndressOpt3Click"){
				worldUIAddon1.OnUndressOpt3Click();		
			}else if(func == "OnUndressOpt4Click"){
				worldUIAddon1.OnUndressOpt4Click();		
			}else{
				core.Info("In WorldUI: Unknown command: " + func);
			}
#endif			
		}
		
#if	(ADDON1)		
		public void LoadSettings(){
			try{
				worldUIAddon1.LoadSettings();
				addonClothSim.LoadSettings();
			}catch (Exception e){
				core.LoggerE(e);
			}
		}
		
		public void ApplySettings(){
			worldUIAddon1.ApplySettings();
			addonClothSim.ApplySettings();
		}

		public void Manage(float time){
			if(time == lastTime){
				time += 0.001f;
			}else if(time < lastTime){
				time = lastTime + 0.001f;
			}
			lastTime = time;

			addonClothSim.Manage(time);
		}	
		
		public void OnDestroy(){
			addonClothSim.OnDestroy();
		}
		
		public void OnOrgasmStart()
		{
			addonClothSim.OnOrgasmStart();
		}
		
		public void OnOrgasmStop()
		{
			addonClothSim.OnOrgasmStop();
		}		
#endif	
	}
}