using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Cotyounoyume
{
    public class WorldUIAddon1{
		public EBATCore core;
		public WorldUI worldUi;
		public AddonManager1 addonManager1;
		
		public AddonClothSimItem addonClothSim;
		public AddonTakeControlItem addonTakeControl;		
		
		public string strUndressAndRemove  = "Undress+Remove";
		public string strUndress           = "Undress";
		public string strUndressForce      = "Undress[Force]";
		public string strUndressHalf       = "Undress(Half)";
		public string strUndressStop       = "Undress(Stop)";
		public string strReverse           = "Reverse Gravity";
		public string strUndressAndReverse = "Undress Reverse";
		public string strUndressRevStrong  = "Undress[Force] Reverse";
		public string strAltSkinWrap       = "Alt Skin Wrap";
		public string strUndressRecover    = "Reset";
		public string strUndressRemove     = "Remove Clothes";
		
		public UIDynamicButton uiUndressAndRemove;
		public UIDynamicButton uiUndress;
		public UIDynamicButton uiUndressForce;
		public UIDynamicButton uiUndressHalf;
		public UIDynamicButton uiUndressStop;
		public UIDynamicButton uiReverse;
		public UIDynamicButton uiUndressAndReverse;
		public UIDynamicButton uiUndressRevStrong;
		public UIDynamicButton uiUndressRecover;
		public UIDynamicButton uiAltSkinWrap;
		public UIDynamicButton uiUndressRemove;
		
		public string strUndressOpt1On     = "Opt1(NG Words) [ON]";
		public string strUndressOpt2On     = "Opt2(ClothSims)[ON]";
		public string strUndressOpt3On     = "Opt3(SkinWraps)[ON]";
		public string strUndressOpt4On     = "SkinWrapToClothSim[ON]";
		public string strUndressOpt1Off    = "Opt1(NG Words) [  ]";
		public string strUndressOpt2Off    = "Opt2(ClothSims)[  ]";
		public string strUndressOpt3Off    = "Opt3(SkinWraps)[  ]";
		public string strUndressOpt4Off    = "SkinWrapToClothSim[  ]";
		public string strUndressOpt1Var;
		public string strUndressOpt2Var;
		public string strUndressOpt3Var;
		public string strUndressOpt4Var;
		public UIDynamicButton uiUndressOpt1;
		public UIDynamicButton uiUndressOpt2;
		public UIDynamicButton uiUndressOpt3;
		public UIDynamicButton uiUndressOpt4;
		
		public string strHint12   = "Help for Undress...";
		
		public string strExposeBreasts     = "Expose Breasts";
		public string strExposeBreastsStrong     = "Tear Off Shirt";
		public string strPullUpSkirt       = "Pull up a Skirt";
		public string strRemoveGameObjects = "Stop";
		
		public string strExpandAddon1      = "Addon1[▶]";
		public string strExpandAddon1Alt   = "Addon1[◀]";
		
		public string strTakeControlOfPlugin   = "Stop Other Plugins";
		public string strTakeControlHint   = "This button allows you to temporarily disable the timeline and other animation plugins.";
		public string strHint1   = "Help for stop other...";
		public string strReturnControlOfPlugin = "Restart";

		public float buttonSizeX3 = 800f;

		public UIDynamicButton uiExposeBreasts;
		public UIDynamicButton uiExposeBreastsStrong;
		public UIDynamicButton uiPullUpSkirt;
		public UIDynamicButton uiRemoveGameObjects;
		
		public UIDynamicButton uiTakeControlOfPlugin;
		public UIDynamicTextField uiTakeControlHint;
		public UIDynamicButton uiReturnControlOfPlugin;
		public UIDynamicButton uiHint1;
		public UIDynamicButton uiHint12;

		public UIDynamicButton uiExpandAddon1;
		public bool expandAddon1 = true;
		
		public string strTakeControlOfExpression = "Take Control Of Expression";
		public string strStopControlOfExpression = "Stop";
		public UIDynamicButton uiTakeControlOfExpression;
		public UIDynamicButton uiStopControlOfExpression;
		
		public WorldUIAddon1(WorldUI worldUi){
			this.worldUi = worldUi;
			this.core = worldUi.core;
		}

		public void LoadSettings(){
			this.addonManager1 = core.addonManager1;
			this.addonClothSim         = addonManager1.addonClothSim;
			this.addonTakeControl      = core.addonTakeControl;			
		}
		
		public void ApplySettings(){
			
		}

		public void RemoveMenuBodyAddon(){
			try{
				
			UIDynamicButton[] buttons = {
				uiUndress, uiUndressForce, uiUndressHalf, uiUndressStop, 
				uiReverse, uiUndressAndReverse, uiUndressRevStrong, uiAltSkinWrap,
				uiUndressRecover, uiUndressRemove, uiUndressAndRemove, 
				uiExposeBreasts, uiExposeBreastsStrong, uiPullUpSkirt, uiRemoveGameObjects,
				uiExpandAddon1, uiUndressOpt1, uiUndressOpt2, uiUndressOpt3, uiUndressOpt4, 
				uiTakeControlOfPlugin, uiReturnControlOfPlugin, uiHint1, uiHint12,
			};

			UIDynamicSlider[] sliders = {
			};

			UIDynamicTextField[] texts = {
			};
			worldUi.RemoveMenuBodyImpl(buttons, sliders, texts);
			
			}catch(Exception e){
				core.LoggerE(e);
			}
		}
		

		public void MakeMenuBodyPartExpandButton(string type){
			if(type == "Addon1"){
				uiExpandAddon1 = MakeButton(strExpandAddon1, -1, worldUi.line);
				uiExpandAddon1.button.onClick.AddListener(OnExpandAddon1);
			}
			worldUi.line++;
		}
		
		public void MakeMenuBodyPartCollapseButton(string type){
			if(type == "Addon1"){
				uiExpandAddon1 = MakeButton(strExpandAddon1Alt, -1, worldUi.line);
				uiExpandAddon1.button.onClick.AddListener(OnCollapseAddon1);
			}
			
			worldUi.line++;
		}
		
		public void MakeMenuBodyAddon(){
			if(core.GetMemoryBool("Addon1")){
				MakeMenuBodyPartCollapseButton("Addon1");
				MakeMenuBodyPartAddon1();
			}else{
				if(!core.GetMemoryBool("isCompact")){
					MakeMenuBodyPartExpandButton("Addon1");
				}
			}
			
			UIDynamicButton[] expandButtons = {
				uiExpandAddon1,
			};
			worldUi.ColoringButton(expandButtons, 235f/255f, 161f/255f, 52f/255f);			
		}
		
		public void MakeMenuBodyPartAddon1(){
			uiUndressRecover = MakeButton(strUndressRecover, -1, worldUi.line);
			uiUndressAndRemove = MakeButton(strUndressAndRemove, 0, worldUi.line);
			uiUndress = MakeButton(strUndress, 1, worldUi.line);
			uiUndressForce = MakeButton(strUndressForce, 2, worldUi.line);
			uiUndressStop = MakeButton(strUndressStop, 3, worldUi.line);
			worldUi.line++;
			
			uiUndressAndReverse = MakeButton(strUndressAndReverse, 1, worldUi.line);
			uiUndressRevStrong  = MakeButton(strUndressRevStrong,  2, worldUi.line);
			uiReverse = MakeButton(strReverse, 3, worldUi.line);
			worldUi.line++;
			
			uiAltSkinWrap   = MakeButton(strAltSkinWrap, 1, worldUi.line);
			uiUndressOpt4   = MakeButton(strUndressOpt4Var, 2, worldUi.line);
			
			if(!core.GetMemoryBool("isCompact")){
			//if(!core.customUi.jsUICompact.val){
				uiHint12        = MakeButton(strHint12, 3, worldUi.line);
				worldUi.ColoringButton(uiHint12, 0f, 0f, 0f);
			}
			worldUi.line++;
			
			uiUndressRemove = MakeButton(strUndressRemove, 0, worldUi.line);
			uiUndressOpt1   = MakeButton(strUndressOpt1Var, 1, worldUi.line);
			uiUndressOpt2   = MakeButton(strUndressOpt2Var, 2, worldUi.line);
			uiUndressOpt3   = MakeButton(strUndressOpt3Var, 3, worldUi.line);
			worldUi.ColoringButton(uiUndressOpt1, 198f/255f, 250f/255f, 192f/255f);
			worldUi.ColoringButton(uiUndressOpt2, 198f/255f, 250f/255f, 192f/255f);
			worldUi.ColoringButton(uiUndressOpt3, 198f/255f, 250f/255f, 192f/255f);
			worldUi.ColoringButton(uiUndressOpt4, 198f/255f, 250f/255f, 192f/255f);
			worldUi.line++;
			
			uiRemoveGameObjects = MakeButton(strRemoveGameObjects, -1, worldUi.line);
			uiExposeBreasts = MakeButton(strExposeBreasts, 0, worldUi.line);
			uiExposeBreastsStrong = MakeButton(strExposeBreastsStrong, 1, worldUi.line);
			uiPullUpSkirt = MakeButton(strPullUpSkirt, 2, worldUi.line);
			worldUi.line++;
			
			uiReturnControlOfPlugin = MakeButton(strReturnControlOfPlugin, -1, worldUi.line);
			uiTakeControlOfPlugin = MakeButton(strTakeControlOfPlugin, 0, worldUi.line);
			if(!core.GetMemoryBool("isCompact")){
				uiHint1 = MakeButton(strHint1, 1, worldUi.line);
				worldUi.ColoringButton(uiHint1, 0f, 0f, 0f);
			}
			worldUi.line++;

			//line13
			uiUndressAndRemove.button.onClick.AddListener(OnUndressAndRemoveClick);
			uiUndress.button.onClick.AddListener(OnUndressClick);
			uiUndressForce.button.onClick.AddListener(OnUndressForceClick);
			uiUndressStop.button.onClick.AddListener(OnUndressStopClick);
			uiReverse.button.onClick.AddListener(OnReverseClick);
			uiUndressAndReverse.button.onClick.AddListener(OnUndressAndReverseClick);
			uiUndressRevStrong.button.onClick.AddListener(OnUndressRevStrongClick);
			uiUndressRecover.button.onClick.AddListener(OnUndressRecoverClick);
			
			uiAltSkinWrap.button.onClick.AddListener(OnAltSkinWrapClick);
			uiUndressRemove.button.onClick.AddListener(OnUndressRemoveClick);
			
			uiUndressOpt1.button.onClick.AddListener(OnUndressOpt1Click);
			uiUndressOpt2.button.onClick.AddListener(OnUndressOpt2Click);
			uiUndressOpt3.button.onClick.AddListener(OnUndressOpt3Click);
			uiUndressOpt4.button.onClick.AddListener(OnUndressOpt4Click);

			uiRemoveGameObjects.button.onClick.AddListener(OnRemoveGameObjectsClick);
			uiExposeBreasts.button.onClick.AddListener(OnExposeBreastsClick);
			uiExposeBreastsStrong.button.onClick.AddListener(OnExposeBreastsStrongClick);
			uiPullUpSkirt.button.onClick.AddListener(OnPullUpSkirtClick);
			
			uiTakeControlOfPlugin.button.onClick.AddListener(OnTakeControlOfPluginsClick);
			uiReturnControlOfPlugin.button.onClick.AddListener(OnReturnControlOfPluginsClick);
			if(!core.GetMemoryBool("isCompact")){
				uiHint1.button.onClick.AddListener(OnHint1Click);
				uiHint12.button.onClick.AddListener(OnHint12Click);				
			}
			
		}
		
		
		public void OnExpandAddon1ValueOnly(){OnExpandCommonValueOnly("Addon1");}
		public void OnCollapseAddon1ValueOnly(){OnCollapseCommonValueOnly("Addon1");}
		
		public void OnExpandCommonValueOnly(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", true);
			}
		}
		
		public void OnCollapseCommonValueOnly(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", false);
			}
		}
		
		public void OnExpandAddon1(){OnExpandCommon("Addon1");}
		public void OnCollapseAddon1(){OnCollapseCommon("Addon1");}

		public void OnExpandCommon(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", true);
			}
			worldUi.RemoveMenuBody();
			worldUi.MakeMenuBody();
		}
		
		public void OnCollapseCommon(string type){
			if(type == "Addon1"){
				core.SetMemoryBool("Addon1", false);
			}
			worldUi.RemoveMenuBody();
			worldUi.MakeMenuBody();
		}
		
		public void LabelSwitch(){
			LabelVarChange();
			LabelUpdate();
		}
				
		public void LabelVarChange(){
			strUndressOpt1Var = (core.addonManager1.holdNGWordsOnGlobal ) ? strUndressOpt1On : strUndressOpt1Off;
			strUndressOpt2Var = (core.addonManager1.holdClothSimOnGlobal) ? strUndressOpt2On : strUndressOpt2Off;
			strUndressOpt3Var = (core.addonManager1.holdSkinWrapOnGlobal) ? strUndressOpt3On : strUndressOpt3Off;
			strUndressOpt4Var = (core.addonManager1.wrapAlterToSimOnGlobal) ? strUndressOpt4On : strUndressOpt4Off;
		}
		
		public void LabelUpdate(){
			core.worldUi.LabelUpdateImpl(uiUndressOpt1, strUndressOpt1Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt2, strUndressOpt2Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt3, strUndressOpt3Var);
			core.worldUi.LabelUpdateImpl(uiUndressOpt4, strUndressOpt4Var);
		}
		
		
		public void OnUndressAndRemoveClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.SetRemoveOptions();
			addonClothSim.UndressAndRemove();
		}

		public void OnUndressClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.SetRemoveOptions();
			addonClothSim.Undress("Undress");
		}

		public void OnUndressForceClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.SetRemoveOptions();
			addonClothSim.Undress("UndressForce");
		}
		
		public void OnReverseClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.Undress("Reverse");
		}
		
		public void OnUndressAndReverseClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.Undress("UndressAndReverse");
		}
		
		public void OnUndressRevStrongClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.Undress("UndressAndReverseForce");
		}
		
		public void OnAltSkinWrapClick(){
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
			addonClothSim.AlterSkinWrap();
		}
		
		public void OnUndressStopClick(){
			addonClothSim.UndressStop();
		}

		public void OnUndressRecoverClick(){
			addonClothSim.RemoveResetClothes();
			addonClothSim.RecoverClothesState();
			addonClothSim.WrapNormal();
			addonClothSim.ResetClothesState();
			addonClothSim.ChangeClothes();
			addonClothSim.BackupClothesState();
		}

		public void OnRemoveGameObjectsClick(){
			core.RemoveGameObjectByName("clothGrabber");
			core.customUnityAssetItem.suffixCount = 0;
		}

		public void OnExposeBreastsClick(){
			addonClothSim.ChangeClothes();
			core.customUnityAssetItem.MakeShirtSpreaders();;
		}

		public void OnExposeBreastsStrongClick(){
			addonClothSim.ChangeClothes();
			core.customUnityAssetItem.MakeShirtSpreaders(strStrengthType:"high");;
		}

		public void OnPullUpSkirtClick(){
			core.customUnityAssetItem.MakePullingSkirtUppers();
		}
		
		public void OnUndressRemoveClick(){
			addonClothSim.RecoverClothesState();
			addonClothSim.BackupClothesState();
			addonClothSim.SetRemoveOptions();
			addonClothSim.RemoveClothes();
		}

		public void OnUndressOpt1Click(){
			core.customUi.ToggleExternal("Hold Clothes containing NGWords");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt2Click(){
			core.customUi.ToggleExternal("Hold Clothes with ClothSim");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt3Click(){
			core.customUi.ToggleExternal("Hold Clothes with AlterSkinWrap");
			core.worldUi.LabelSwitch();
		}

		public void OnUndressOpt4Click(){
			core.customUi.ToggleExternal("Alter SkinWrap to ClothSim");
			core.worldUi.LabelSwitch();
		}

		public void OnTakeControlOfPluginsClick(){
			addonTakeControl.TakeControlOfPlugins();
			addonTakeControl.TakeControlOfEverythingButPlugins();
		}

		public void OnHint1Click(){
			core.hint.StopOtherPluginsHint();
		}

		public void OnHint12Click(){
			core.hint.RemoveOptionsHint();
		}

		public void OnReturnControlOfPluginsClick(){
			addonTakeControl.ReturnControlOfPlugins();
			addonTakeControl.ReturnControlOfEverythingButPlugins();
		}
		

		public UIDynamicButton MakeButton(string name, int x, int y, float width = 0f, float height = 0f){
			return worldUi.MakeButtonForAddon(name, x, y, width, height);
		}

		public UIDynamicTextField MakeTextField(string text, int x, int y, float width = 0f, float height = 0f){
			return worldUi.MakeTextFieldForAddon(text, x, y, width, height);
		}

		public UIDynamicSlider MakeSlider(string name, int x, int y, float min, float max, float current){
			return worldUi.MakeSlider(name, x, y, min, max, current);
		}
	}
}